import openpyxl
import sqlite3
import os
import time
from openpyxl.styles import Alignment
from PySide6.QtWidgets import QMessageBox


def Arrange_Data1(list1):
    # 最终return的
    list2 = []
    for data1 in list1:
        # 点名
        # 存每一行的数据
        resultlist = []
        pn = data1[0].decode('utf-8')
        resultlist.append(pn)
        resultlist.append(data1[1])
        resultlist.append(data1[2])
        resultlist.append(data1[3])
        resultlist.append(data1[4])
        resultlist.append(data1[5])
        # 判定
        an1 = data1[6].decode('utf-8')
        resultlist.append(an1)
        # 两个结果名字（旧新）
        name1 = data1[7].decode('utf-8')
        resultlist.append(name1)
        name2 = data1[8].decode('utf-8')
        resultlist.append(name2)
        list2.append(resultlist)
    return list2


# 复测成果表
def Arrange_Data2(list1):
    # 最终return的
    list2 = []
    for data1 in list1:
        # 点名
        # 存每一行的数据
        resultlist = []
        pn = data1[0].decode('utf-8')
        resultlist.append(pn)
        resultlist.append(data1[1])
        resultlist.append(data1[2])
        resultlist.append(data1[3])
        resultlist.append(data1[4])
        resultlist.append(data1[5])
        resultlist.append(data1[6])
        resultlist.append(data1[7])
        # 判定
        an1 = data1[8].decode('utf-8')
        resultlist.append(an1)
        # 两个结果名字（旧新）
        name1 = data1[9].decode('utf-8')
        resultlist.append(name1)
        name2 = data1[10].decode('utf-8')
        resultlist.append(name2)
        list2.append(resultlist)

    return list2


def openpyxl_write(file_name, dbpath, filename):
    utf_en = filename.encode('utf-8')
    # 新建对应的excel
    wb = openpyxl.Workbook()
    ws2 = wb.create_sheet('复测成果表')
    ws1 = wb.create_sheet('复测基准归算表')
    ws3 = wb.create_sheet('基准归算模型')
    ws5 = wb['Sheet']
    wb.remove(ws5)

    # w1部分(基准归算表)
    # 提取数据
    db = sqlite3.connect(dbpath)
    cursor1 = db.cursor()
    sqlstr11 = 'select PointName,Cal_X,Cal_Y,Last_CalX,Last_CalY,Last_CalP,Dis_Ass,Last_ResultName,New_ResultName from GS_Result_Point WHERE TableName = ?'
    cursor1.execute(sqlstr11, (utf_en,))
    # 获取结果集
    result1 = cursor1.fetchall()
    # 整理数据
    plist1 = Arrange_Data1(result1)
    ws1.column_dimensions['A'].width = 5
    ws1.column_dimensions['B'].width = 15
    ws1.column_dimensions['C'].width = 15
    ws1.column_dimensions['D'].width = 8
    ws1.column_dimensions['E'].width = 8
    ws1.column_dimensions['F'].width = 8
    ws1.column_dimensions['G'].width = 5
    ws1.merge_cells(start_row=1, end_row=1,
                    start_column=1, end_column=7)
    ws1.cell(1, 1).value = '复测基准归算与位移判定'
    ws1.merge_cells(start_row=2, end_row=3,
                    start_column=1, end_column=1)
    ws1.cell(2, 1).value = '点名'
    ws1.merge_cells(start_row=2, end_row=2,
                    start_column=2, end_column=3)
    ws1.cell(2, 2).value = plist1[0][8] + '基准归算成果'
    ws1.merge_cells(start_row=2, end_row=2,
                    start_column=4, end_column=6)
    ws1.cell(2, 4).value = plist1[0][7] + '-归算成果(mm)'
    ws_area = ws1["A1:H3"]
    alignment_center = Alignment(horizontal='center', vertical='center')  # 指定区域单元格居中
    for i in ws_area:
        for j in i:
            j.alignment = alignment_center
    alignment_right = Alignment(horizontal='right', vertical='center')
    ws1.merge_cells(start_row=2, end_row=3,
                    start_column=7, end_column=7)
    ws1.cell(2, 7).value = '位移判定'
    ws1.cell(2, 7).alignment = Alignment(wrap_text=True)
    ws1.cell(3, 2).value = 'X(mm)'
    ws1.cell(3, 3).value = 'Y(mm)'
    ws1.cell(3, 4).value = '△X'
    ws1.cell(3, 5).value = '△Y'
    ws1.cell(3, 6).value = '△P'
    row1 = 4
    for data1 in plist1:
        ws1.cell(row1, 1).value = data1[0]
        ws1.cell(row1, 2).value = round(data1[1], 4)
        ws1.cell(row1, 3).value = round(data1[2], 4)
        ws1.cell(row1, 4).value = round(data1[3], 1)
        ws1.cell(row1, 5).value = round(data1[4], 1)
        ws1.cell(row1, 6).value = round(data1[5], 1)
        if data1[6] == '稳定':
            ws1.cell(row1, 7).value = ''
        else:
            ws1.cell(row1, 7).value = data1[6]
        row1 = row1 + 1

    # ws2部分(复测成果表)
    # 提取数据
    sqlstr1 = 'select PointName,Last_X,Last_Y,Result_X,Result_Y,Last_ResultX,Last_ResultY,Last_ResultP,Dis_Ass,Last_ResultName,New_ResultName from GS_Result_Point WHERE TableName = ?'
    cursor1.execute(sqlstr1, (utf_en,))
    # 获取结果集
    result2 = cursor1.fetchall()
    # 整理数据
    plist2 = Arrange_Data2(result2)
    ws2.column_dimensions['A'].width = 5
    ws2.column_dimensions['B'].width = 15
    ws2.column_dimensions['C'].width = 15
    ws2.column_dimensions['D'].width = 15
    ws2.column_dimensions['E'].width = 15
    ws2.column_dimensions['F'].width = 8
    ws2.column_dimensions['G'].width = 8
    ws2.column_dimensions['H'].width = 8
    ws2.column_dimensions['I'].width = 5
    ws2.merge_cells(start_row=1, end_row=1,
                    start_column=1, end_column=3)
    ws2.cell(1, 1).value = '前期成果'
    ws2.merge_cells(start_row=1, end_row=1,
                    start_column=4, end_column=9)
    ws2.cell(1, 4).value = '本期成果'
    ws_area = ws2["A1:I2"]
    alignment_center = Alignment(horizontal='center', vertical='center')  # 指定区域单元格居中
    for i in ws_area:
        for j in i:
            j.alignment = alignment_center
    alignment_right = Alignment(horizontal='right', vertical='center')
    ws2.merge_cells(start_row=2, end_row=3,
                    start_column=1, end_column=1)
    ws2.cell(2, 1).value = '点名'
    ws2.merge_cells(start_row=2, end_row=2,
                    start_column=2, end_column=3)
    ws2.cell(2, 2).value = plist2[0][9]
    ws2.merge_cells(start_row=2, end_row=2,
                    start_column=4, end_column=5)
    ws2.cell(2, 4).value = plist2[0][10]
    ws2.merge_cells(start_row=2, end_row=2,
                    start_column=6, end_column=8)
    newname_1 = plist2[0][9] + '-' + plist2[0][10] + '(mm)'
    ws2.cell(2, 6).value = newname_1
    ws2.merge_cells(start_row=2, end_row=3,
                    start_column=9, end_column=9)
    ws2.cell(2, 9).value = '位移判定'
    ws2.cell(2, 9).alignment = Alignment(wrap_text=True)
    ws2.cell(3, 2).value = 'X(m)'
    ws2.cell(3, 3).value = 'Y(m)'
    ws2.cell(3, 4).value = 'X(m)'
    ws2.cell(3, 5).value = 'Y(m)'
    ws2.cell(3, 6).value = '△X'
    ws2.cell(3, 7).value = '△Y'
    ws2.cell(3, 8).value = '△XY'
    row2 = 4
    for data2 in plist2:
        ws2.cell(row2, 1).value = data2[0]
        ws2.cell(row2, 2).value = round(data2[1], 4)
        ws2.cell(row2, 3).value = round(data2[2], 4)
        ws2.cell(row2, 4).value = round(data2[3], 4)
        ws2.cell(row2, 5).value = round(data2[4], 4)
        ws2.cell(row2, 6).value = round(data2[5], 1)
        ws2.cell(row2, 7).value = round(data2[6], 1)
        ws2.cell(row2, 8).value = round(data2[7], 1)
        if data2[8] == '稳定':
            ws2.cell(row2, 9).value = ''
        else:
            ws2.cell(row2, 9).value = data2[8]
        row2 = row2 + 1

    # ws3部分(公式)
    # 提取数据
    sqlstr2 = 'select Last_ResultName,New_ResultName,Formula_X1,Formula_X2,Formula_X3,Formula_Y1,Formula_Y2,Formula_Y3 from GS_Trans_Param WHERE TableName = ?'
    cursor1.execute(sqlstr2, (utf_en,))
    # 获取结果集
    result3 = cursor1.fetchall()
    newname = result3[0][1].decode('utf-8')
    lastname = result3[0][0].decode('utf-8')
    ws3.column_dimensions['A'].width = 75
    ws_area = ws3["A1:A5"]
    alignment_center = Alignment(horizontal='left', vertical='center')  # 指定区域单元格居中
    for i in ws_area:
        for j in i:
            j.alignment = alignment_center
    str1 = newname + '--' + lastname + '已知系统转换公式:'
    ws3.cell(1, 1).value = str1
    str2 = 'X=(' + str(round(result3[0][2], 14)) + ')·x+(' + str(round(result3[0][3], 14)) + ')·y+(' + str(
        round(result3[0][4], 11)) + ')'
    ws3.cell(2, 1).value = str2
    str3 = 'Y=(' + str(round(result3[0][5], 14)) + ')·x+(' + str(round(result3[0][6], 14)) + ')·y+(' + str(
        round(result3[0][7], 11)) + ')'
    ws3.cell(3, 1).value = str3
    str4 = '式中:x、y为' + newname
    ws3.cell(4, 1).value = str4
    str5 = '     X、Y为' + lastname + '已知系统的' + newname + '归算坐标'
    ws3.cell(5, 1).value = str5
    # 保存
    # wb.save(outpath)
    # 保存 Excel 文件
    excel_filename = f"控制网复测平面基准计算成果表{time.strftime('%Y%m%d_%H%M%S')}.xlsx"
    excel_filepath = os.path.join(file_name, excel_filename)
    wb.save(excel_filepath)


# 主函数 写入excel文件
def main_function(ui, file_path, dbpath, excelname):
    # dbpath = r"D:\4work_now\20240819GS\ControlNetwork\ControlNetwork\UI\SQL\DataBase.db"
    # outpath = r'D:\4work_now\20240819GS\JPG\GS成果表.xlsx'
    # file_path = r'D:\4work_now\20240819GS\二滩_20240816.xls'
    file_name = os.path.dirname(file_path)
    try:
        openpyxl_write(file_name, dbpath, excelname)
        QMessageBox.information(ui, '成功', f'成果文件已成功导出到 {file_name}')
    except Exception as e:
        QMessageBox.critical(ui, '错误', f'导出过程中发生错误: {str(e)}')

